<?php

/**
 * SecureTrading STPP Shopping Carts
 * Viart 4.1
 * Module Version 2.5.3
 * Last Updated 13 March 2013
 * Written by Peter Barrow for SecureTrading Ltd.
 * http://www.securetrading.com
 */

?><?php

require_once(dirname(__FILE__) . '/securetrading_stpp_lib/securetrading_stpp/STPPLoader.php');
require_once(dirname(__FILE__) . '/securetrading_stpp_lib/ViArtSTAPI.class.php');

if (isset($_POST['MD'])) { // If ready to perform 3D Query.
	$root_folder_path = "../";
	$is_admin_path = TRUE;
	define('INSTALLED', TRUE);
	include_once($root_folder_path ."includes/common.php");
	include_once($root_folder_path ."includes/order_items.php");
	
	$payment_parameters = array();
	$pass_parameters = array();
	$post_parameters = '';
	$pass_data = array();
	$variables = array();
	get_payment_parameters($_GET['order_id'], $payment_parameters, $pass_parameters, $post_parameters, $pass_data, $variables);
	
	$stapi = new ViArtSTAPI();
	$stapi->setConnection($payment_parameters['host'], $GLOBALS['payment_parameters']['port']);
	$stapi->run3dCallback($payment_parameters['alias'], FALSE);
	$error_message = isset($stapi->errorParams['message']) && !empty($stapi->errorParams['message']) ? $stapi->errorParams['message'] : FALSE;
}
else {
	switch(strtoupper($variables['cc_type'])) {
		case 'MC':
			$paymenttype = 'MASTERCARD';
			break;
		default:
			$paymenttype = strtoupper($variables['cc_type']);
	}
	
	$cardError = array_key_exists($paymenttype, ViArtSTAPI::getCardsArray()) ? FALSE : TRUE;
	
	if ($cardError) {
		$error_message = sprintf("%s cards are not accepted by SecureTrading.", ucfirst(strtolower($paymenttype)));
	}
	else {
		$requestObject = new stdClass;

		$requestObject->sitereference = $GLOBALS['payment_parameters']['sitereference'];
		$requestObject->alias = $GLOBALS['payment_parameters']['alias'];
		$requestObject->accounttypedescription = 'ECOM';
		$requestObject->ip = $_SERVER['REMOTE_ADDR'];

		$requestObject->amount = ViArtStapi::formatPrice($GLOBALS['payment_parameters']['amount'], $GLOBALS['payment_parameters']['currencycode']);
		$requestObject->currencycode = $GLOBALS['payment_parameters']['currencycode'];

		$requestObject->billingprefix = '';
		$requestObject->billingfirstname = $GLOBALS['payment_parameters']['billingfirstname'];
		$requestObject->billinglastname = $GLOBALS['payment_parameters']['billinglastname'];
		$requestObject->billingteltype = '';
		$requestObject->billingtelno = $GLOBALS['payment_parameters']['billingtelephone'];
		$requestObject->billingemail = $GLOBALS['payment_parameters']['billingemail'];

		$requestObject->billingpremise = $GLOBALS['payment_parameters']['billingpremise'];
		$requestObject->billingstreet = $GLOBALS['payment_parameters']['billingstreet'];
		$requestObject->billingtown = $GLOBALS['payment_parameters']['billingtown'];
		$requestObject->billingcounty = $GLOBALS['payment_parameters']['billingcounty'];
		$requestObject->billingpostcode = $GLOBALS['payment_parameters']['billingpostcode'];
		$requestObject->billingcountry = $GLOBALS['payment_parameters']['billingcountryiso2a'];

		$requestObject->customerprefix = '';
		$requestObject->customerfirstname = $GLOBALS['payment_parameters']['customerfirstname'];
		$requestObject->customerlastname = $GLOBALS['payment_parameters']['customerlastname'];
		$requestObject->customerteltype = '';
		$requestObject->customertelno = $GLOBALS['payment_parameters']['customertelephone'];
		$requestObject->customeremail = $GLOBALS['payment_parameters']['customeremail'];

		$requestObject->customerpremise = $GLOBALS['payment_parameters']['customerpremise'];
		$requestObject->customerstreet = $GLOBALS['payment_parameters']['customerstreet'];
		$requestObject->customertown = $GLOBALS['payment_parameters']['customertown'];
		$requestObject->customercounty = $GLOBALS['payment_parameters']['customercounty'];
		$requestObject->customerpostcode = $GLOBALS['payment_parameters']['customerpostcode'];
		$requestObject->customercountry = $GLOBALS['payment_parameters']['customercountryiso2a'];

		$requestObject->settleduedate = $GLOBALS['payment_parameters']['settleduedate'];
		$requestObject->settlestatus = $GLOBALS['payment_parameters']['settlestatus'];

		$requestObject->paymenttype  = $paymenttype;
		$requestObject->pan = get_session('session_cc_number');
		$requestObject->expirydate = str_replace(' ', '', $variables['cc_expiry_date']);
		$requestObject->securitycode = get_session('session_cc_code');

		$settings = get_session('session_settings');
		
		$requestObject->termurl = $settings['site_url'] . 'order_confirmation.php?order_id=' . $GLOBALS['order_id'] . '&vc=' . get_param("vc") . '&action=save';
		
		set_session('session_cc_number', NULL);
		set_session('session_cc_code', NULL);

		$stapi = new ViArtSTAPI();
		$stapi->setConnection($GLOBALS['payment_parameters']['host'], $GLOBALS['payment_parameters']['port']);
		$stapi->runSTAPI($requestObject, $GLOBALS['payment_parameters']['use_3d_secure']);
		$error_message = isset($stapi->errorParams['message']) && !empty($stapi->errorParams['message']) ? $stapi->errorParams['message'] : FALSE;
	}
}

if (!empty($error_message)) {
	$settings = get_session('session_settings');
	$error_message .= "<p>To return to the checkout, please click <a href='" . $settings['site_url'] . "order_info.php'>here</a>.</p>";
}